#include "renderer.hpp"

#include "glclasses.hpp"

#include "game.hpp"

#include "state/trace.hpp"
#include "state/object.hpp"
#include "state/missile.hpp"
#include "state/player.hpp"
#include "state/planet.hpp"
#include "state/ship.hpp"
#include "state/explosion.hpp"

class PolygonModel;

namespace endofthejedi {

    class RendererPolygon3d : public Renderer {
        public:
            void setup();
            void render(const game::State *state) override;

        private:
            // all models are also here (for easy reloading etc.)
            std::vector<PolygonModel*>  m_models;

            // and with a specific variable name here
            PolygonModel               *m_atomicBomb;

            // for rendering everything
            Shader m_shader;
    };
}
